module Biro
  class Error < StandardError; end

  class << self
    def config
      Configuration.instance
    end

    def log(level, message)
      config.logger.send(level, message)
    end

    def configure
      yield config
    end

    def development?
      config.development?
    end

    def gateways
      @gateways ||= {}
    end
  end
end

require 'biro/version'
require 'biro/utils'
require "biro/configuration"
require "biro/response"
require "biro/gateways"
