require_relative 'base_builder'

module Biro
  module Bvs
    class DebitsRequestBuilder < BaseBuilder
      def build
        @parameters = {
          transaction: { size: 8, type: "T", value: "CSR60" },
          version:  { size: 2, type: "T", value: "01" },
          reserved_applicant: { size: 10, type: "T", value: "" },
          reserved_bvs: { size: 20, type: "T", value: "" },
          service_code: { size: 8, type: "N", value: @username },
          password: { size: 8, type: "T", value: @password },
          search_type: { size: 8, type: "T", value: "SPCIT" },
          reserverd_bvs_2: { size: 4, type: "T", value: ""},
          response_type: { size: 1, type: "T", value: "2" },
          document_type: { size: 1, type: "T", value: "1" },
          document: { size: 14, type: "N", value: @document },
          reserverd_bvs_3: { size: 235, type: "T", value: ""},
          facilitator_code: { size: 8, type: "N", value: "" },
          reserverd_bvs_4: { size: 2, type: "T", value: ""},
          response_trans_type: { size: 1, type: "T", value: "C" },
          finish_marker: { size: 1, type: "T", value: "X" }
        }

        build_string
      end
    end
  end
end
