module Biro
  module Bvs
    class ScoreRequestBuilder < BaseBuilder
      def build
        @parameters = {
          transaction: { size: 8, type: "T", value: "CSR60" },
          version:  { size: 2, type: "T", value: "01" },
          reserved_applicant: { size: 10, type: "T", value: "" },
          reserved_bvs: { size: 20, type: "T", value: "" },
          service_code: { size: 8, type: "N", value: @username },
          password: { size: 8, type: "T", value: @password },
          search_type: { size: 8, type: "T", value: "SCORE" },
          search_version: { size: 2, type: "T", value: "04" },
          response_type: { size: 1, type: "T", value: "2" },
          response_trans_type: { size: 1, type: "T", value: "C" },
          document_type: { size: 1, type: "T", value: "1" },
          document: { size: 14, type: "N", value: @document },
          score_model: { size: 2, type: "T", value: "63" },
          source_cep: { size: 8, type: "N", value: "" },
          facilitator_code: { size: 8, type: "N", value: "" },
          finish_marker: { size: 1, type: "T", value: "X" }
        }

        build_string
      end
    end
  end
end
